 <?php

// $Id: mm_s3_test.inc,v 1.1.2.1 2008/06/29 10:56:50 arthuregg Exp $
  
/**
 * This file provides some testing configuration for the s3 module
 * files is based on http://freshmeat.net/projects/storage3
 * original author is: apokalyptik@apokalyptik.com
 * 
 */

/* **************************************************** */
/* Possible configuration */
/* **************************************************** */


$test_bucket = variable_get('mm_s3_bucket', str_replace(" ", "_", $conf['site_name'])) .'_test';

$test_upload = drupal_get_path('module', 'mm_s3'). '/test.png';

// file name is the file name
$test_upload_name = basename($test_upload);

// path to the download file. drupal files should be writeable
$test_download = file_directory_path() . '/s3_download_'. $test_upload_name; 


/* **************************************************** */


// get the s3 drivers
mm_s3_drivers_check();

$myAccessKeyId = variable_get('mm_s3_key', null);
$mySecretAccessKey = variable_get('mm_s3_skey', null);

  // Create our Amazon S3 Service Interface 
  $s3 = new storage3($myAccessKeyId, $mySecretAccessKey, "https://s3.amazonaws.com/");
  
  echo('The following buckets currently exist on the server: <br />');
  $buckets = $s3->lsBuckets();
  if (! count($buckets)) {
    echo ('No buckets <br />');
  }
  else {
    print "---------------------------------- <br />";
    if ($buckets){ 
      foreach($buckets as $bucket) {
        print $bucket . "<br />";
      }
      print "---------------------------------- <br />";
    }
  }
  

  /* Create a test bucket */
 
  // does bucket exist?
  if ($s3->fileExists($test_bucket, '')) {
    echo "Bucket '$test_bucket' already exists <br />";   
  }
  else {
    if ( $s3->mkBucket($test_bucket) ) {
      echo "Created bucket on s3! <br />";     
    }
    else {
      echo "could not create bucket <br />";     
    }
  }
 
  /* Put a test file to the service */
  if ( $s3->putFile($test_upload, $test_bucket, $test_upload_name) ) {
    print "Put test file '$test_upload_name' on S3 in bucket '$test_bucket' <br />";
    
    print "---------------------------------- <br />";
    print "Now downloading file from S3 <br />";

    /* Fetch the file we just put into the amazon service */
    if ( $s3->saveFile($test_bucket, $test_upload_name,  $test_download) ) {
      echo "Retrieved uploaded file from s3 successfully! <br />";

       /* Make sure that it contains the same data as the file we put in */
      $comp1 = md5_file($test_upload);
      $comp2 = substr($s3->responseHeaders['etag'], 1, -1);
      if ( $comp1 === $comp2 ) {
        echo "InFile == OutFile! <br /> ";
      } else {
        echo "InFile != OutFile <br /> Something is wrong with the signatures of these files";
      }
  
      print "<br />---------------------------------- <br />";
      
      // now delete the file we just saved
      file_delete($test_download);
      print "Deleted the file $test_download locally <br />";
 
      /* Remove the file we placed on s3 */
      if ($s3->rmFile($test_bucket, $test_upload)) { 
        echo "<br />Deleted the file from amazon"; }
      else {
        echo "<br />Could not delete the file from amazon<br />";
      } 
       
      /* Remove (recursively) the test bucket */
      $s3->rmBucket("$test_bucket", 1);

      /* clean up the downloaded file */
      if ($delete_test) { 
        unlink($testOutFile);
      }
      
    } 
    else {
      echo "Could not save file locally. Check write permissions for webserver $test_download <br />";
    }
  } 
  else {
    echo "Could Not Put File\r\n";
    print_r($s3->why());
  }
 
  // remove the test bucket 
  if ( $s3->rmBucket($test_bucket, 1) ) {
    echo "Removed bucket '$test_bucket' <br />";
  } else {
    echo "Could Not Remove Bucket\r\n";
    print_r($s3->why());
  }
